enemyList = {}
EN1 = love.graphics.newImage("enemy.png")
EN2 = love.graphics.newImage("enemy2.png")


-- enemy creation
function MakeEnemy(types)
	local e = {} 
	e.psystem = psystem:clone()
    e.psystem:setParticleLifetime(1, 1.5) -- Particles live at least 2s and at most 5s.
    e.psystem:setEmissionRate(20)
    e.psystem:setSizeVariation(1)
    e.psystem:setLinearAcceleration(20, -2, 0, 2); -- Random movement in all directions.
    e.psystem:setColors(247, 197, 5, 255, 255, 0, 0, 0); -- Fade to black.
	
	e.dead = nil
	if types <= 75 then -- 75% chance for creating first (smaller) type
		e.image = EN1
		e.HP= 1
		e.s = lvm(100,170)
		e.t=1
	else	-- second (bigger) type
		e.image = EN2
		e.HP = 4
		e.s = lvm(40,80)
		e.t=2
	end
	e.h = e.image:getHeight( )
	e.w = e.image:getWidth( )
	e.enemy_shot_timer = 0
	-- randomized colors
	e.color1 = lvm(150,255)
	e.color2 = lvm(150,255)
	e.color3 = lvm(150,255)
	
	e.x = 820
	e.y = lvm(0,600-e.h)
	e.effect = effect:clone( )
	table.insert(enemyList, e)
end

-- enemy drawing
function DrawEnemy()
	for i,e in ipairs(enemyList) do
		g.setColor (e.color1, e.color2, e.color3)
		g.draw(e.image, e.x, e.y, 0, 1, 1, 0, 0)
		if e.t == 1 then
			e.psystem:setLinearAcceleration(200, -2, 0, 2)
			g.draw(e.psystem, (e.x+EN1:getWidth( )), e.y + (EN1:getHeight( ) * 0.5-1))
		else
			g.draw(e.psystem, (e.x+EN2:getWidth( )), e.y + (EN2:getHeight( ) -18))
			g.draw(e.psystem, (e.x+EN2:getWidth( )), e.y + (EN2:getHeight( ) -5))
		end
	end
end


function EnemyMove(dt)
	for i,e in pairs(enemyList) do
		e.enemy_shot_timer = e.enemy_shot_timer + (1 * dt)
		if e.enemy_shot_timer >= 2 then
		
			if e.t == 1 then
			MakeBullet(e.x+(e.w/2),e.y+(e.h/2),-1, enemy)
			else
			MakeBullet(e.x,e.y+2,-1, enemy) MakeBullet(e.x,e.y+14,-1, enemy)
			end
			e.enemy_shot_timer = 0 + lvm(0,0.75)
			e.effect:play()
			e.effect:rewind()
		end
		-- enemy moves	
		e.x = e.x - e.s * dt
	
		-- quickly made negative score, needs reworking later
		if e.x <=-100 then
			if e.t == 1 then score = score - 10	end
			if e.t == 2 then score = score - 30 end
		end
		
		-- enemy is removed when it off map
		if e.x <=-100 then
			table.remove(enemyList, i)
		end
		-- enemy dying condition
		if e.HP == 0 then
			e.dead = true
		end
		
		-- removing a dead enemy and point granting
		if e.dead then
			if e.t == 1 then score = score + 10 else score = score + 30 end
			table.remove(enemyList, i)
		end	
		-- update for enemy's particle system
		e.psystem:update(dt)
		
	end
end
--[[ unused enemy-enemy collision
function EnemyCollision()
	for i,e in pairs(enemyList)do
		if e.y <= 0 then e.y = e.y + 1 end
		if e.y+e.h >= 600 then e.y = e.y -1 end
		for i2,e2 in pairs(enemyList) do
			if i ~= i2 then
				if CheckCollision(e.x, e.y, e.w, e.h,  e2.x, e2.y, e2.w, e2.h) == true then
					if e.x >= e2.x then
						e.x = e2.x + e2.w
						e2.s = e.s
					end
				end
			end
		end
	end
end
--]]