g = love.graphics
lvm = love.math.random
require 'player'
require 'enemy'
require 'bullet'
require 'background'
effect = love.audio.newSource('gunshot.ogg')

dt = math.min(1/60)


-- Timer for enemy spawning
function Timer(dt)
	timer = timer + 1*dt
	if timer >= spawntime then
		timer = spawntime*lvm(0,0.5)
		MakeEnemy(lvm(1,100))
	end
end
	
	-- function for collision
	function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
		return 	x1 < x2+w2 and
				x2 < x1+w1 and
				y1 < y2+h2 and
				y2 < y1+h1
		end
	

--============================--
--============================--
--============================--

function love.load()
	time = 0 -- time survived
	score = 0 -- score
	gamestate=0 -- current gamestate (0=menu, 1=game)
	spawntime = .60 -- enemy spawning interval
	menu_choice = 1 -- option choosen in menu
	menuarrow = 300 -- position of pointer in menu
	love.mouse.setVisible(false) --hides mouse arrow

end

function love.update(dt)

	-- keypresses for menu
	function love.keypressed(key)
		if key == 'return' and menu_choice == 2 then
			love.event.quit() end
		if key == 'return' and gamestate == 0 and menu_choice == 1 then
			gamestate = 1; time = 0 ; score = 0 end
		if key == 'escape' and gamestate == 1 then
			gamestate = 0 end
		if key =='up' and gamestate == 0 and menu_choice ~= 1 then menu_choice = menu_choice - 1 ; menuarrow = menuarrow - 20 end
		if key =='down' and gamestate == 0 and menu_choice ~= 2 then menu_choice = menu_choice + 1 ; menuarrow = menuarrow + 20 end
	
end

-- if player dies, game goes back to menu
for i,e in pairs(playerList) do
	if e.dead == true then gamestate = 0 end
end

-- removes all stuff in case of player's death or going back to menu
if gamestate == 0 then
for k in pairs (enemyList) do
    enemyList[k] = nil
end
for k in pairs (playerList) do
    playerList[k] = nil
end
for k in pairs (bullets) do
    bullets[k] = nil
end
love.audio.stop()
timer=0

end

--Play state: creates player, enemies, updates stuff
if gamestate == 1 then
	if #playerList == 0 then MakePlayer(100,100) end
	Movement(dt)
	Timer(dt)
	EnemyMove(dt)
	BulletUpdate(dt)
	Enemy_Bullet_Collision()
	Player_Bullet_Collision()
	psystem:update(dt)
	Background_update(dt)
	time = time +1*dt
end


end

function love.draw()
-- draws background if game is playing
	if gamestate == 1 then
		Draw_Background()
		g.print("Time: "..string.format("%.2f", time), 10, 25)
		g.print("Score:  "..score, 10, 40)
	end
	
-- drawing entities
	DrawEnemy()
	DrawPlayer()
	DrawBullets()
	
	g.setColor(225,225,225)
	g.print("FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	if gamestate == 0 then
	-- prints menu
	g.print("Start", 400, 300)
	g.print("Exit", 400, 320)
	g.print(">", 380, menuarrow)
	g.print("Score:  "..score, 380, 400)
	g.print("Time: "..string.format("%.2f", time), 380, 430)
	end

end