playerList = {} -- table for player entity
bursttimer = 0 -- timer for player's shoots

-- particle system for engine
local img = love.graphics.newImage('particle.png')
psystem = love.graphics.newParticleSystem(img, 50)
psystem:setParticleLifetime(0.5, 0.75) -- Particles live at least 2s and at most 5s.
psystem:setEmissionRate(10)
psystem:setSizeVariation(1)
psystem:setLinearAcceleration(-10, -2, 0, 2); -- Random movement in all directions.
psystem:setColors(247, 197, 5, 255, 255, 0, 0, 0); -- Fade to black.


function MakePlayer(x,y)
	local p = {}
	p.dead = false
	p.HP = 10
	p.x = x
	p.y = y
	p.image = love.graphics.newImage("player.png")
	p.h = p.image:getHeight( )
	p.w = p.image:getWidth( )
	p.s = 250
	table.insert(playerList, p)
end

function Movement(dt)
-- stuff from previous versions: in case you are pushed from both sides, you die
leftcrush=false
rightcrush=false
	
	-- velocity reset and shot timer
	for i,e in ipairs(playerList) do
		bursttimer = bursttimer + 1 * dt
		xvel=0
		yvel=0
		-- if player goes right...
		if love.keyboard.isDown("right") then
			xvel = e.s
			psystem:setLinearAcceleration(-300, -2, 0, 2)
			psystem:setEmissionRate(40)
		-- if player goes left
		elseif love.keyboard.isDown("left") then
			xvel = -e.s
			psystem:setLinearAcceleration(-25, -2, 0, 2)
			psystem:setEmissionRate(10)
		else psystem:setLinearAcceleration(-100, -2, 0, 2);psystem:setEmissionRate(15)
		end
		
		-- collision with enemy
		local oldX = e.x
		e.x = e.x + (xvel*dt)
			for i2,e2 in pairs (enemyList) do
				if CheckCollision(e.x,e.y,e.w,e.h, e2.x,e2.y,e2.w,e2.h) == true then
					if e.x <= e2.x then
						e.x=oldX
						leftcrush = true
					end
					if e.x >= e2.x then
						e.x=oldX
						rightcrush = true
					end
					e.x = e.x - e2.s * dt
				end
			end
		-- if player goes down...
		if love.keyboard.isDown("down") then
			yvel = e.s
		end
		-- if players goes up...
		if love.keyboard.isDown("up") then
			yvel = -e.s
		end
		--collision with enemy
		local oldY = e.y
		e.y = e.y + (yvel*dt)
			for i2,e2 in pairs (enemyList) do
				if CheckCollision(e.x,e.y,e.w,e.h, e2.x,e2.y,e2.w,e2.h) == true then
					if e.y <= e2.y then
						e.y=oldY
					end
					if e.y >= e2.y then
						e.y=oldY
					end
				end
			end
		
		-- shoot button 
		if love.keyboard.isDown("z") then
			 if bursttimer >= 0.1 then
				for i,e in ipairs(playerList) do
					MakeBullet(e.x+(e.w/2),e.y+(e.h/2),1,'player') end -- place where bullet show
					effect:play()
					effect:rewind()
					bursttimer =0
			end
		end
		
		
	--[[ stuff for precise control, unused and kinda broken
		if love.keyboard.isDown("lshift") then
			xvel = xvel/2
			yvel = yvel/2
		end
		
	function love.keyreleased(key)
		if key == "lshift" then
			xvel = 0
			yvel = 0
		end
	end
		--]]
		
		-- if crushed, you die
	if rightcrush and leftcrush then e.dead = true end
	if e.HP < 1 then e.dead = true end
	
	-- map collision
	if e.x+e.w >=800 then e.x = oldX end
	if e.x <=0 then e.x = oldX end
	if e.y <= 0 then e.y = oldY end
	if e.y+e.h >= 600 then e.y = oldY end
	end
end

-- drawing the player
function DrawPlayer()
	for i,e in ipairs(playerList) do
	g.setColor (255, 255, 255)
	g.draw(e.image, e.x, e.y, 0, 1, 1, 0, 0)
	g.draw(psystem, e.x, e.y + (e.h * 0.5-1))
		g.setColor (255, 0, 0)
		-- Health Points drawing
		for i = 1, e.HP, 1 do
			g.rectangle('fill', 100+(i*10) , 10, 5, 10)
		end
			g.print("HP: ", 85,8)
	end
end